package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.Rank;
import net.kyori.adventure.text.Component;
import org.bukkit.GameMode;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.ADMIN, source = SourceType.BOTH)
@CommandParameters(description = "Quickly change your own gamemode to spectator, or define someone's username to change theirs.", usage = "/<command> <[partialname]>", aliases = "gmsp")
public class Command_spectator extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            if (isConsole())
            {
                msg(Component.text("When used from the console, you must define a target player."));
                return true;
            }

            playerSender.setGameMode(GameMode.SPECTATOR);
            msg(Component.text("Your gamemode has been set to spectator."));
            return true;
        }

        Player player = getPlayer(args[0]);

        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        msg(Component.text("Setting " + player.getName() + " to gamemode spectator"));
        msg(player, Component.text(sender.getName() + " set your gamemode to spectator."));
        player.setGameMode(GameMode.SPECTATOR);
        return true;
    }
}